# HG changeset patch
# Parent 7d00455945ec97c5851ac0d735da7c3cfbd8e39c
rathaxes: rewrite/refactor all the e1000 device dependent code

diff --git a/rathaxes/samples/e1000/CMakeLists.txt b/rathaxes/samples/e1000/CMakeLists.txt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/CMakeLists.txt
+++ b/rathaxes/samples/e1000/CMakeLists.txt
@@ -17,9 +17,9 @@
                      dma.blt
                      pci.blt
                      socket.blt
-                     e1000.blt
-                     ethernet.blt)
+                     ethernet.blt
+                     e1000.blt)
 
-IF (LINUX_KBUILD_DIR)
-    ADD_RATHAXES_LKM(e1000 e1000_src)
-ENDIF (LINUX_KBUILD_DIR)
+#IF (LINUX_KBUILD_DIR)
+#    ADD_RATHAXES_LKM(e1000 e1000_src)
+#ENDIF (LINUX_KBUILD_DIR)
diff --git a/rathaxes/samples/e1000/e1000.blt b/rathaxes/samples/e1000/e1000.blt
old mode 100755
new mode 100644
--- a/rathaxes/samples/e1000/e1000.blt
+++ b/rathaxes/samples/e1000/e1000.blt
@@ -1,8 +1,148 @@
 with e1000, Ethernet, Socket, DMA, PCI, LKM, Log, Builtin
 {
-    template type   e1000::RxDescriptor()
+    template type e1000::Register()
     {
-        decl    data_types()
+        decl data_types()
+        {
+            E1000_CTRL          = 0x00000, /* Device Control - RW */
+            E1000_CTRL_DUP      = 0x00004, /* Device Control Duplicate (Shadow) - RW */
+            E1000_STATUS        = 0x00008, /* Device Status - RO */
+            E1000_EEPROM_FLASH  = 0x00010, /* EEPROM/Flash Control - RW */
+            E1000_EEPROM_READ   = 0x00014, /* EEPROM Read - RW */
+            E1000_CTRL_EXT      = 0x00018, /* Extended Device Control - RW */
+            E1000_FLA           = 0x0001C, /* Flash Access - RW */
+            E1000_MDIC          = 0x00020, /* MDI Control - RW */
+            E1000_IMS           = 0x000D0, /* Interrupt Mask Set */
+            E1000_IMC           = 0x000D8, /* Interrupt Mask Clear */
+            E1000_ICR           = 0x000C0, /* Interrupt Cause Read - R/clr */
+            E1000_FCAL          = 0x00028, /* Flow Control Address Low */
+            E1000_FCAH          = 0x0002c, /* Flow Control Address High */
+            E1000_FCT           = 0x00030, /* Flow Control Type */
+            E1000_RCTL          = 0x00100, /* Receive Control */
+            E1000_FCTTV         = 0x00170, /* Flow Control Transmit Timer Value */
+            E1000_TCTL          = 0x00400, /* Transmit Control */
+            E1000_CRCERRS       = 0x04000, /* CRC Error Count (base address of the statistic register spaces) */
+            E1000_RAL           = 0x05400, /* Receive Address Low */
+            E1000_RAH           = 0x05404, /* Receive Address High */
+            E1000_MTA           = 0x05200, /* Multicast Table Array */
+            E1000_RDBAL         = 0x02800, /* Receive Descriptor Base Address (Low 32 bits) */
+            E1000_RDBAH         = 0x02804, /* Receive Descriptor Base Address (High 32 bits) */
+            E1000_RDLEN         = 0x02808, /* Receive Descriptor Length */
+            E1000_RDH           = 0x02810, /* Receive Descriptor Head */
+            E1000_RDT           = 0x02818, /* Receive Descriptor Tail */
+            E1000_TDBAL         = 0x03800, /* Transmit Descriptor Base Address (Low 32 bits) */
+            E1000_TDBAH         = 0x03804, /* Transmit Descriptor Base Address (High 33 bits) */
+            E1000_TDLEN         = 0x03808, /* Transmit Descriptor Length */
+            E1000_TDH           = 0x03810, /* Transmit Descriptor Head */
+            E1000_TDT           = 0x03818, /* Transmit Descriptor Tail */
+        }
+
+        map
+        {
+        }
+    }
+
+    template type e1000::Commands()
+    {
+        decl data_types()
+        {
+            E1000_CMD_FD                    = 0x00000001, /* Full duplex.0=half; 1=full */
+            E1000_CMD_BEM                   = 0x00000002, /* Endian Mode.0=little,1=big */
+            E1000_CMD_PRIOR                 = 0x00000004, /* Priority on PCI. 0=rx,1=fair */
+            E1000_CMD_GIO_MASTER_DISABLE    = 0x00000004, /* Blocks new Master requests */
+            E1000_CMD_LRST                  = 0x00000008, /* Link reset. 0=normal,1=reset */
+            E1000_CMD_TME                   = 0x00000010, /* Test mode. 0=normal,1=test */
+            E1000_CMD_SLE                   = 0x00000020, /* Serial Link on 0=dis,1=en */
+            E1000_CMD_ASDE                  = 0x00000020, /* Auto-speed detect enable */
+            E1000_CMD_SLU                   = 0x00000040, /* Set link up (Force Link) */
+            E1000_CMD_ILOS                  = 0x00000080, /* Invert Loss-Of Signal */
+            E1000_CMD_SPD_SEL               = 0x00000300, /* Speed Select Mask */
+            E1000_CMD_SPD_10                = 0x00000000, /* Force 10Mb */
+            E1000_CMD_SPD_100               = 0x00000100, /* Force 100Mb */
+            E1000_CMD_SPD_1000              = 0x00000200, /* Force 1Gb */
+            E1000_CMD_BEM32                 = 0x00000400, /* Big Endian 32 mode */
+            E1000_CMD_FRCSPD                = 0x00000800, /* Force Speed */
+            E1000_CMD_FRCDPX                = 0x00001000, /* Force Duplex */
+            E1000_CMD_D_UD_EN               = 0x00002000, /* Dock/Undock enable */
+            E1000_CMD_D_UD_POLARITY         = 0x00004000, /* Defined polarity of Dock/Undock indication in SDP[0] */
+            E1000_CMD_FORCE_PHY_RESET       = 0x00008000, /* Reset both PHY ports, through PHYRST_N pin */
+            E1000_CMD_EXT_LINK_EN           = 0x00010000, /* enable link status from external LINK_0 and LINK_1 pins */
+            E1000_CMD_SWDPIN0               = 0x00040000, /* SWDPIN 0 value */
+            E1000_CMD_SWDPIN1               = 0x00080000, /* SWDPIN 1 value */
+            E1000_CMD_SWDPIN2               = 0x00100000, /* SWDPIN 2 value */
+            E1000_CMD_SWDPIN3               = 0x00200000, /* SWDPIN 3 value */
+            E1000_CMD_SWDPIO0               = 0x00400000, /* SWDPIN 0 Input or output */
+            E1000_CMD_SWDPIO1               = 0x00800000, /* SWDPIN 1 input or output */
+            E1000_CMD_SWDPIO2               = 0x01000000, /* SWDPIN 2 input or output */
+            E1000_CMD_SWDPIO3               = 0x02000000, /* SWDPIN 3 input or output */
+            E1000_CMD_RST                   = 0x04000000, /* Global reset */
+            E1000_CMD_RFCE                  = 0x08000000, /* Receive Flow Control enable */
+            E1000_CMD_TFCE                  = 0x10000000, /* Transmit flow control enable */
+            E1000_CMD_RTE                   = 0x20000000, /* Routing tag enable */
+            E1000_CMD_VME                   = 0x40000000, /* IEEE VLAN mode enable */
+            E1000_CMD_PHY_RST               = 0x80000000, /* PHY Reset */
+            E1000_CMD_SW2FW_INT             = 0x02000000, /* Initiate an interrupt to manageability engine */
+            E1000_INTR_TXDW                 = 0x00000001, /* Transmit desc written back */
+            E1000_INTR_TXQE                 = 0x00000002, /* Transmit Queue empty */
+            E1000_INTR_LSC                  = 0x00000004, /* Link Status Change */
+            E1000_INTR_RXSEQ                = 0x00000008, /* rx sequence error */
+            E1000_INTR_RXDMT0               = 0x00000010, /* rx desc min. threshold (0) */
+            E1000_INTR_RXO                  = 0x00000040, /* rx overrun */
+            E1000_INTR_RXT0                 = 0x00000080, /* rx timer intr (ring 0) */
+            E1000_INTR_MDAC                 = 0x00000200, /* MDIO access complete */
+            E1000_RAH_AV                    = (1 << 31),  /* Set the MAC Address as Valid */
+            E1000_RCTL_EN                   = (1 << 1),   /* Receiver Enable */
+            E1000_RCTL_BSEX                 = (1 << 25),  /* Buffer Size Extension */
+            E1000_RCTL_BSIZE_256            = ((1 << 16) | (1 << 17)),
+            E1000_RCTL_BSIZE_512            = (1 << 17),
+            E1000_RCTL_BSIZE_1024           = (1 << 16),
+            E1000_RCTL_BSIZE_2048           = 0,
+            E1000_RCTL_BSIZE_4096           = (E1000_RCTL_BSEX | (1 << 16) | (1 << 17)),
+            E1000_RCTL_BSIZE_8192           = (E1000_RCTL_BSEX | (1 << 17)),
+            E1000_RCTL_BSIZE_16384          = (E1000_RCTL_BSEX | (1 << 16)),
+            E1000_TCTL_EN                   = (1 << 1),   /* Transmitter Enable */
+            E1000_TCTL_PSP                  = (1 << 3),   /* Pad Short Packet */
+        }
+
+        map
+        {
+        }
+    }
+
+    template type e1000::TxDescriptorFlag()
+    {
+        decl data_types()
+        {
+            E1000_TXD_DTYP_D        = 0x00100000, /* Data Descriptor */
+            E1000_TXD_DTYP_C        = 0x00000000, /* Context Descriptor */
+            E1000_TXD_POPTS_IXSM    = 0x01,       /* Insert IP checksum */
+            E1000_TXD_POPTS_TXSM    = 0x02,       /* Insert TCP/UDP checksum */
+            E1000_TXD_CMD_EOP       = 0x01000000, /* End of Packet */
+            E1000_TXD_CMD_IFCS      = 0x02000000, /* Insert FCS (Ethernet CRC) */
+            E1000_TXD_CMD_IC        = 0x04000000, /* Insert Checksum */
+            E1000_TXD_CMD_RS        = 0x08000000, /* Report Status */
+            E1000_TXD_CMD_RPS       = 0x10000000, /* Report Packet Sent */
+            E1000_TXD_CMD_DEXT      = 0x20000000, /* Descriptor extension (0 = legacy) */
+            E1000_TXD_CMD_VLE       = 0x40000000, /* Add VLAN tag */
+            E1000_TXD_CMD_IDE       = 0x80000000, /* Enable Tidv register */
+            E1000_TXD_STAT_DD       = 0x00000001, /* Descriptor Done */
+            E1000_TXD_STAT_EC       = 0x00000002, /* Excess Collisions */
+            E1000_TXD_STAT_LC       = 0x00000004, /* Late Collisions */
+            E1000_TXD_STAT_TU       = 0x00000008, /* Transmit underrun */
+            E1000_TXD_CMD_TCP       = 0x01000000, /* TCP packet */
+            E1000_TXD_CMD_IP        = 0x02000000, /* IP packet */
+            E1000_TXD_CMD_TSE       = 0x04000000, /* TCP Seg enable */
+            E1000_TXD_STAT_TC       = 0x00000004, /* Tx Underrun */
+        }
+
+        map
+        {
+        }
+    }
+
+    template type e1000::RxDescriptor()
+    {
+        decl data_types()
         {
             __le64          buff_addr;
             __le16          length;
@@ -12,13 +152,39 @@
             __le16          special;
         }
 
-        chunk   LKM::includes()
+        map
         {
-            #include <linux/types.h>
         }
+    }
 
-        method  init()
+    // This is a generic tx descriptor for the e1000. When you use TCP
+    // Segmentation Offload (TSO) the hardware actually uses two types of
+    // tx descriptors in its tx ring:
+    // - context descriptors: this descriptor doesn't actually point to data to
+    //   send but initialize the offloading engine for the data descriptor that
+    //   follow;
+    // - data descriptors: this descriptor points to data from the skbuffs.
+    template type e1000::TxDescriptor()
+    {
+        decl data_types()
         {
+            __le64                  buff_addr;
+            union {
+                __le32              data;
+                struct {
+                    __le16          length;
+                    unsigned char   csum_offset; /* CSO */
+                    unsigned char   cmd;
+                }                   fields;
+            }                       lower;
+            union {
+                __le32              data;
+                struct {
+                    unsigned char   status;
+                    unsigned char   csum_start; /* CSS */
+                    __le16          special;
+                }                   fields;
+            }                       upper;
         }
 
         map
@@ -26,44 +192,131 @@
         }
     }
 
-    /*
-     * This is a generic tx descriptor for the e1000. When you use TCP
-     * Segmentation Offload (TSO) the hardware actually uses two types of
-     * tx descriptors in its tx ring:
-     * - context descriptors: this descriptor doesn't actually point to data to
-     *   send but initialize the offloading engine for the data descriptor that
-     *   follow;
-     * - data descriptors: this descriptor points to data from the skbuffs.
-     */
-    template type   e1000::TxDescriptor()
+    template type e1000::Buffer()
     {
-        decl    data_types()
+        decl data_types()
         {
-            __le64                  buff_addr;
-            union
-            {
-                __le32              data;
-                struct
-                {
-                    __le16          length;
-                    unsigned char   csum_offset; /* CSO */
-                    unsigned char   cmd;
-                }                   fields;
-            }                       lower;
-            union
-            {
-                __le32              data;
-                struct
-                {
-                    unsigned char   status;
-                    unsigned char   csum_start; /* CSS */
-                    __le16          special;
-                }                   fields;
-            }                       upper;
+            ${Socket::SKBuff}   sk_buff;
+            ${DMA::DMAHandle}   dma;
         }
 
-        method init()
+        method init(Socket::SKBuff sk_buff, DMA::DMAHandle dma)
         {
+            ${self.sk_buff} = ${sk_buff};
+            ${self.dma} = ${dma};
+        }
+
+        map
+        {
+            sk_buff: ${self}->sk_buff;
+            dma: ${self}->dma;
+        }
+    }
+
+    template type e1000::MMIO()
+    {
+        decl data_types()
+        {
+            unsigned char   *io;
+        }
+
+        // XXX: we'll need those functions until we get working methods (#46):
+
+        chunk LKM::prototypes()
+        {
+            static unsigned int rtx_e1000_reg_read32(${e1000::MMIO}, ${e1000::Register});
+            static void         rtx_e1000_reg_write32(${e1000:::MMIO}, ${e1000::Register}, ${Builtin::number});
+            static void         rtx_e1000_reg_set32(${e1000:::MMIO}, ${e1000::Register}, ${Builtin::number});
+            static void         rtx_e1000_reg_unset32(${e1000:::MMIO}, ${e1000::Register}, ${Builtin::number});
+        }
+
+        chunk LKM::code()
+        {
+            static unsigned int rtx_e1000_reg_read32(${e1000::MMIO} io, ${e1000::Register} reg)
+            {
+                return ioread32(${local.io.io} + reg);
+            }
+
+            static void         rtx_e1000_reg_write32(${e1000:::MMIO} io, ${e1000::Register} reg, ${Builtin::number} value)
+            {
+                return iowrite32(value, ${local.io.io} + reg);
+            }
+
+            static void         rtx_e1000_reg_set32(${e1000:::MMIO} io, ${e1000::Register} reg, ${Builtin::number} value)
+            {
+                return iowrite32(rtx_e1000_reg_read32(io, reg) | value, ${local.io.io} + reg);
+            }
+
+            static void         rtx_e1000_reg_unset32(${e1000:::MMIO} io, ${e1000::Register} reg, ${Builtin::number} value)
+            {
+                return iowrite32(rtx_e1000_reg_read32(io, reg) & ~value, ${local.io.io} + reg);
+            }
+        }
+
+        method init(Builtin::symbol io)
+        {
+            ${self.io} = ${io};
+        }
+
+        method read32(e1000::Register reg)
+        {
+            ioread32(${self.io} + ${local.reg});
+        }
+
+        method write32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(${local.value}, ${self.io} + ${local.reg});
+        }
+
+        method set32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(ioread32(${self.io} + ${local.reg}) | value, ${self.io} + ${local.reg});
+        }
+
+        method unset32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(ioread32(${self.io} + ${local.reg}) & ~value, ${self.io} + ${local.reg});
+        }
+
+        map
+        {
+            io: ((unsigned char *)(${self}));
+        }
+    }
+
+    template type e1000::Ring()
+    {
+        decl data_types()
+        {
+            ${e1000::MMIO}          io;
+            ${DMA::DMAHandle}       dma;
+            ${Builtin::symbol.ref}  descs;
+            ${Builtin::number}      size;
+            ${e1000::Buffer.ref}    buffs;
+        }
+
+        chunk LKM::prototypes()
+        {
+            static void rtx_e1000_ring_init(${e1000::Ring.ref}, ${e1000::MMIO},
+                                            ${Builtin::number}, ${Builtin::number});
+        }
+
+        chunk LKM::code()
+        {
+            static void rtx_e1000_ring_init(${e1000::Ring.ref} self,
+                                            ${e1000::MMIO} io,
+                                            ${Builtin::number} desc_count,
+                                            ${Builtin::number} desc_size)
+            {
+                memset(self, 0, sizeof(*self));
+                self->size = ALIGN(desc_count * desc_size, 4096);
+                self->io = io;
+            }
+        }
+
+        method init(e1000::MMIO io, Builtin::number desc_count, Builtin::number desc_size)
+        {
+            rtx_e1000_ring_init(&${self}, ${io}, ${desc_count}, ${desc_size});
         }
 
         map
@@ -71,32 +324,27 @@
         }
     }
 
-    /*
-     * Ring of e1000::RxDescriptors and their corresponding skbuffs.
-     *
-     * - size: total size of the ring in bytes.
-     * - base: address of the ring (we can't use the typedef here until we get
-     *   CNorm unstrict);
-     * - dma_base: (physical) address of the ring where the device can access
-     *   the different descriptors;
-     * - skbuffs: array of the skbuffs and their dma (physical) address
-     *   associated with each descriptor.
-     */
-    template type   e1000::RxRing()
+    template type e1000::RxRing()
     {
-        decl    data_types()
+        decl data_types()
         {
-            unsigned int                    size;
-            ${e1000::RxDescriptor.ref}      base;
-            dma_addr_t                      dma_base;
-            ${Socket::SKBuff}               skbuffs[${config.rx_ring_size}];
+            ${e1000::Ring}  ring;
         }
 
-        method init()
+        chunk LKM::prototypes()
         {
+            static int  rtx_e1000_alloc_rx_ressources(${e1000::RxRing.ref});
         }
 
-        chunk   Ethernet::adapter_init_rx(Ethernet::Device rtx_ether_ctx)
+        chunk LKM::code()
+        {
+            static int  rtx_e1000_alloc_rx_ressources(${e1000::RxRing.ref} self)
+            {
+                return 0;
+            }
+        }
+
+        chunk Ethernet::adapter_init_rx(Ethernet::Device rtx_ether_ctx)
         {
             {
                 ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
@@ -167,18 +415,16 @@
                  * Allocate the skbuffs, map them for DMA, and write their address
                  * in the corresponding descriptor.
                  */
-                for (i = 0; i != ${config.rx_ring_size}; ++i)
-                {
+                for (i = 0; i != ${config.rx_ring_size}; ++i) {
                     ${Socket::SKBuff.ref} skbuff = &hw_ctx->rx_ring.skbuffs[i];
-                    // XXX #46: ${rtx_ether_ctx.init_rx_skbuff(local.skbuff, config.rx_buffer_len)};
-                    if (rtx_ethernet_init_rx_skbuff(${local.skbuff}, ${config.rx_buffer_len}))
-                    {
+                    // XXX #46: ${rtx_ether_ctx.alloc_rx_skbuff(local.skbuff, config.rx_buffer_len)};
+                    if (rtx_ethernet_alloc_rx_skbuff(${local.skbuff}, ${config.rx_buffer_len})) {
                         ${Log::info("adapter_init_rx: cannot allocate a skbuff for the rx ring")};
                         goto err_skbuffs_alloc;
                     }
-                    // XXX #46: ${local.skbuff.map_from(rtx_ether_ctx.device)};
-                    if (rtx_socket_skbuff_map(${local.skbuff}, ${rtx_ether_ctx.device}, RTX_DMA_FROM_DEVICE))
-                    {
+                    /* XXX: recuperer le dma handle et le placer correctement dans le descripteur. */
+                    ${DMA::map(local.rtx_ether_ctx.device, local.skbuff.data, local.skbuff.len, RTX_DMA_FROM_DEVICE)}
+                    if (${DMA::map(local.rtx_ether_ctx.device, local.skbuff.data, local.skbuff.len, RTX_DMA_FROM_DEVICE)}) {
                         ${Log::info("adapter_init_rx: cannot dma-map a skbuff for the rx ring")};
                         goto err_skbuffs_map;
                     }
@@ -212,8 +458,7 @@
                 goto init_rx_ok;
 
             err_skbuffs_alloc:
-                while (i--)
-                {
+                while (i--) {
                     dma_unmap_single(
                             ${rtx_ether_ctx.device},
                             /* XXX Leaking cast because of the array: */
